image: node:latest

cache:
  paths:
    - node_modules/

stages:
  - build
  - test
  - deploy

build:
  stage: build
  script:
    - npm install
  only:
    - master
    - master-docs

lint:
  stage: test
  script:
    - npm run lint
  only:
    - master
    - master-docs

test:
  stage: test
  before_script:
    - adduser --disabled-password --gecos "" testy
    - chmod -R 777 /root
    - cd /home/testy
    - runuser -m --session-command 'git clone $CI_PROJECT_URL orpin-cli' testy
    - cd orpin-cli
    - git checkout $CI_COMMIT_REF_NAME
    - chmod -R 777 lib/tests/fixtures/**/*
  script:
    - runuser -m --session-command 'npm install' testy
    - runuser -m --session-command 'npm run test:parallel' testy
  only:
    - master
    - master-docs

coverage:
  stage: test
  before_script:
    - adduser --disabled-password --gecos "" testy
    - chmod -R 777 /root
    - cd /home/testy
    - runuser -m --session-command 'git clone $CI_PROJECT_URL orpin-cli_dos' testy
    - cd orpin-cli_dos
    - git checkout $CI_COMMIT_REF_NAME
    - chmod -R 777 lib/tests/fixtures/**/*
    - curl -L https://codeclimate.com/downloads/test-reporter/test-reporter-latest-linux-amd64 > ./cc-test-reporter
    - chmod +x ./cc-test-reporter
    - ./cc-test-reporter before-build
  script:
    - runuser -m --session-command 'npm install' testy
    - runuser -m --session-command 'npm run coverage:parallel:ci' testy
    - runuser -m --session-command 'npm run coverage:report' testy
  after_script:
    - cd /home/testy/orpin-cli_dos
    - ./cc-test-reporter after-build --exit-code $?
  only:
    - master

cli_check:
  stage: test
  before_script:
    - npm link
  script:
    - orpin -v
    - orpin -k -c ./lib/tests/fixtures/bootstrap_example/aok/.orpinrc
  after_script:
    - npm unlink
  only:
    - master
    - master-docs
    - feature/schemify

code_quality:
  stage: test
  image: docker:stable
  allow_failure: true
  services:
    - docker:stable-dind
  variables:
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
  script:
    - |
      if ! docker info &>/dev/null; then
        if [ -z "$DOCKER_HOST" -a "$KUBERNETES_PORT" ]; then
          export DOCKER_HOST='tcp://localhost:2375'
        fi
      fi
    - docker run
        --env SOURCE_CODE="$PWD"
        --volume "$PWD":/code
        --volume /var/run/docker.sock:/var/run/docker.sock
        "registry.gitlab.com/gitlab-org/security-products/codequality:12-0-stable" /code
  artifacts:
    reports:
      codequality: gl-code-quality-report.json
    expire_in: 1 week
  dependencies: []
  only:
    - master
  except:
    variables:
      - $CODE_QUALITY_DISABLED

pages:
  stage: deploy
  before_script:
    - git clone https://github.com/braintree/jsdoc-template
  script:
    - npm run doc
    - mv ./docs ./public
  after_script:
    - rm -rf jsdoc-template
  artifacts:
    paths:
      - public
  only:
    - master-docs
